/**
 * Крайне простой эмулятор UFM
 */

module ufmemu
(
    input   arclk,
    input   arshft,
    input   drclk,
    input   ardin,
    input   drshft,
    output  drdout
);

assign drdout = din[15];

// -----------------------------------------------------------------------------
reg [15:0] memory[512];
initial $readmemh("tb.hex", memory, 0);
// -----------------------------------------------------------------------------

reg [ 8:0] address;
reg [15:0] din;

always @(posedge arclk) if (arshft) address <= {address[7:0], ardin}; else address <= address + 1'b1;
always @(posedge drclk) if (drshft) din <= din << 1; else din <= memory[address];

endmodule
